[#ftl attributes={"generated.type":"blueprint"}]
[#--

    ~~~~~~licensing~~~~~~
    file-adapter
    ==========
    Copyright (C) 2020 - 2023 EmDev LLC
    ==========
    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

         http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
    ~~~~~~/licensing~~~~~~

--]
<?xml version="1.0" encoding="UTF-8"?>
<blueprint xmlns="http://www.osgi.org/xmlns/blueprint/v1.0.0"
           xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
           xmlns:cm="http://aries.apache.org/blueprint/xmlns/blueprint-cm/v1.1.0"
           xsi:schemaLocation="
               http://www.osgi.org/xmlns/blueprint/v1.0.0 https://www.osgi.org/xmlns/blueprint/v1.0.0/blueprint.xsd"
           >

    <service interface="org.apache.camel.Component" ref="[=objectId]">
        <service-properties>
            <entry key="connection.name" value="[=objectId]"/>
        </service-properties>
    </service>

	[#if properties??]
		[#if properties.ext_createResourceProvider??]
			[#if properties.ext_createResourceProvider]
	<!-- RESOURCE PROVIDER BEAN -->
	<bean id="[=objectId].resourceProvider" class="ru.entaxy.esb.resources.provider.FileResourceProvider">
		<property name="protocol" value="[=objectId]" />
		<property name="rootDirectory" value="[=properties.rootDirectory]" />
	</bean>

    <service interface="ru.entaxy.esb.resources.EntaxyResourceProvider" ref="[=objectId].resourceProvider">
        <service-properties>
            <entry key="connection.name" value="[=objectId]"/>
            <entry key="protocol" value="[=objectId]"/>
        </service-properties>
    </service>
			[/#if]	
		[/#if]
	[/#if]

    <bean id="[=objectId]" class="ru.entaxy.platform.adapter.file.ExtendedFileComponent">
        [#if properties??]
        	[#list properties as key, value]
        		[#if !key?starts_with("##") && !key?starts_with("__") && !key?starts_with("ext_")] [#-- we skip additional properties --]
	        		[#if key?starts_with("file_")] [#-- we add parent component properties --]
		<property name="[=key[5..]]" value="[=value]"/>
					[#else]        		
        <property name="[=key]" value="[=value]"/>
        			[/#if]
        		[/#if]
        	[/#list]
        [/#if]
    </bean>

</blueprint>