/*-
 * ~~~~~~licensing~~~~~~
 * object-factory
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.base.objects.factory;

public interface EntaxyFactoryElements {

	public interface EntaxyFactoryTypedElement {
		
		String getType();
		
	}

	public interface EntaxyFactoryLabeledElement {
		
		String getLabel();
		
		default boolean hasLabel(String label) {
			if ((label==null) || (label.trim().length() == 0) )
				return false;
			if (getLabel() == null)
				return false;
			String test = label.trim();
			String[] labels = getLabel().split(",");
			for (int i=0; i<labels.length; i++)
				if (labels[i].trim().equalsIgnoreCase(test))
					return true;
			return false;
		}
		
	}

	public interface EntaxyFactoryCommonElement extends EntaxyFactoryTypedElement {
		
		String getId();
		String getDisplayName();
		String getDescription();
		
	}
	
	public interface EntaxyFactoryExtendedElement extends EntaxyFactoryCommonElement, EntaxyFactoryLabeledElement {
		
		String getCategory();
		
	}
	
}
