/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.base.objects.service.tracker;

import java.util.List;

import ru.entaxy.platform.base.objects.service.impl.EntaxyObjectServiceImpl;
import ru.entaxy.platform.base.objects.service.impl.TrackedEntaxyObject;
import ru.entaxy.platform.base.support.osgi.tracker.BundleTrackerCustomizerListener;

public class TrackedEntaxyObjectCustomizerListener implements BundleTrackerCustomizerListener<List<TrackedEntaxyObject>> {

	protected EntaxyObjectServiceImpl objectServiceImpl;
	
	public TrackedEntaxyObjectCustomizerListener(EntaxyObjectServiceImpl objectServiceImpl) {
		super();
		this.objectServiceImpl = objectServiceImpl;
	}
	
	
	@Override
	public void added(List<TrackedEntaxyObject> managedObject) {
		this.objectServiceImpl.addObjects(managedObject);
	}

	@Override
	public void modified(List<TrackedEntaxyObject> managedObject) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void removed(List<TrackedEntaxyObject> managedObject) {
		this.objectServiceImpl.removeObjects(managedObject);
	}

}
