/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.base.objects.shell;

import org.apache.karaf.shell.api.action.Action;
import org.apache.karaf.shell.api.action.Command;
import org.apache.karaf.shell.api.action.lifecycle.Service;
import org.apache.karaf.shell.support.table.ShellTable;

import ru.entaxy.platform.base.objects.EntaxyObject;

@Service
@Command(name = "object-list", scope = EntaxyObjectServiceSupport.OBJECTS_SCOPE)
public class ListObjects extends EntaxyObjectServiceSupport implements Action {

	@Override
	public Object execute() throws Exception {
		
		ShellTable shellTable = new ShellTable();
		shellTable.column("Id");
		shellTable.column("Type");
		shellTable.column("Scope");
		shellTable.column("Full Id");
		shellTable.column("Factory Id");
		shellTable.column("Bundle Id");
		
		for (EntaxyObject object: objectService.getObjects()) 
			shellTable.addRow().addContent(
					object.getId(),
					object.getType(),
					object.getScope(),
					object.getObjectFullId(),
					object.getFactoryId(),
					object.getBundleInfo().getBundleId()
			);
		
		shellTable.print(System.out);
		
		return null;
	}

}
