/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.base.objects.shell.completers;

import java.util.List;
import java.util.stream.Collectors;

import org.apache.karaf.shell.api.action.lifecycle.Reference;
import org.apache.karaf.shell.api.action.lifecycle.Service;
import org.apache.karaf.shell.api.console.CommandLine;
import org.apache.karaf.shell.api.console.Completer;
import org.apache.karaf.shell.api.console.Session;

import ru.entaxy.platform.base.objects.EntaxyObjectService;

@Service
public class ObjectCompleter implements Completer {

	@Reference
	EntaxyObjectService objectService;

	@Override
	public int complete(Session session, CommandLine commandLine, List<String> candidates) {
		candidates.addAll(
			objectService.getObjects().stream()
			.map(obj->obj.getObjectFullId())
			.collect(Collectors.toList())
				);
		return 0;
	}
	
	
	
}
