/*-
 * ~~~~~~licensing~~~~~~
 * resources-service
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.resources.tracker;

import java.util.Collections;
import java.util.List;
import java.util.Map;

import org.osgi.framework.Bundle;
import org.osgi.framework.BundleEvent;

import ru.entaxy.platform.base.support.osgi.tracker.UniformBundleTrackerCustomizer;

public class ResourceProviderCustomizer extends UniformBundleTrackerCustomizer<List<ResourceProvider>> {

	@Override
	protected List<ResourceProvider> createManagedObject(Bundle bundle, BundleEvent event,
			Map<String, List<?>> filterResults) {
		return Collections.singletonList(new ResourceProvider(bundle));
	}

}
