/*-
 * ~~~~~~licensing~~~~~~
 * schema-soap
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.runtime.core.infrastructure.schema.soap.cxf;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.xml.bind.annotation.XmlSeeAlso;

/**
 * This class was generated by Apache CXF 3.3.6
 * 2022-11-24T13:47:15.641+03:00
 * Generated source version: 3.3.6
 *
 */
@WebService(targetNamespace = "http://www.entaxy.ru/registry-schema-service/", name = "registry-schema-service")
@XmlSeeAlso({ObjectFactory.class})
@SOAPBinding(parameterStyle = SOAPBinding.ParameterStyle.BARE)
public interface RegistrySchemaService {

    @WebMethod
    @WebResult(name = "getResourceInfoListResponse", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", partName = "response")
    public GetResourceInfoList getResourceInfoListByFullPath(

        @WebParam(partName = "request", name = "getResourceInfoListByFullPathRequest", targetNamespace = "http://www.entaxy.ru/registry-schema-service/")
        GetResourceInfoListByFullPathRequest request
    );

    @WebMethod(action = "http://www.entaxy.ru/registry-schema-service/get-resourceInfo-info-list")
    @WebResult(name = "getResourceInfoListResponse", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", partName = "response")
    public GetResourceInfoList getResourceInfoList(

        @WebParam(partName = "request", name = "getResourceInfoListRequest", targetNamespace = "http://www.entaxy.ru/registry-schema-service/")
        GetResourceInfoListRequest request
    );

    @WebMethod(action = "http://www.entaxy.ru/registry-schema-service/reload-resourceInfo")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", partName = "response")
    public java.lang.String reloadResource(

        @WebParam(partName = "request", name = "ResourceType", targetNamespace = "http://www.entaxy.ru/registry-schema-service/")
        ResourceType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/registry-schema-service/get-resourceInfo")
    @WebResult(name = "FullResourceType", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", partName = "response")
    public FullResourceType getResource(

        @WebParam(partName = "request", name = "getResourceRequest", targetNamespace = "http://www.entaxy.ru/registry-schema-service/")
        long request
    );

    @WebMethod(action = "http://www.entaxy.ru/registry-schema-service/load-resourceInfo-info")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", partName = "response")
    public java.lang.String loadResourceInfo(

        @WebParam(partName = "request", name = "loadResourceInfoRequest", targetNamespace = "http://www.entaxy.ru/registry-schema-service/")
        ResourceInfoType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/registry-schema-service/remove-resourceInfo-info")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", partName = "response")
    public java.lang.String removeResourceInfo(

        @WebParam(partName = "request", name = "removeResourceInfoRequest", targetNamespace = "http://www.entaxy.ru/registry-schema-service/")
        java.lang.String request
    );

    @WebMethod(action = "http://www.entaxy.ru/registry-schema-service/load-resourceInfo")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", partName = "response")
    public java.lang.String loadResource(

        @WebParam(partName = "request", name = "loadResourceRequest", targetNamespace = "http://www.entaxy.ru/registry-schema-service/")
        LoadResourceType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/registry-schema-service/get-resourceInfo-info-list-by-name")
    @WebResult(name = "getResourceInfoListResponse", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", partName = "response")
    public GetResourceInfoList getResourceInfoListByName(

        @WebParam(partName = "request", name = "getResourceInfoListByNameRequest", targetNamespace = "http://www.entaxy.ru/registry-schema-service/")
        GetResourceInfoListByNameRequest request
    );

    @WebMethod(action = "http://www.entaxy.ru/registry-schema-service/get-resourceInfo-info-list-by-namespace")
    @WebResult(name = "getResourceInfoListResponse", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", partName = "response")
    public GetResourceInfoList getResourceInfoListByNamespace(

        @WebParam(partName = "request", name = "getResourceInfoListByNamespaceRequest", targetNamespace = "http://www.entaxy.ru/registry-schema-service/")
        GetResourceInfoListByNamespaceRequest request
    );

    @WebMethod
    @WebResult(name = "getResourceInfoListResponse", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", partName = "response")
    public GetResourceInfoList getResourceInfoListByPath(

        @WebParam(partName = "request", name = "getResourceInfoListByPathRequest", targetNamespace = "http://www.entaxy.ru/registry-schema-service/")
        GetResourceInfoListByPathRequest request
    );

    @WebMethod(action = "http://www.entaxy.ru/registry-schema-service/remove-resourceInfo")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", partName = "response")
    public java.lang.String removeResource(

        @WebParam(partName = "request", name = "removeResourceRequest", targetNamespace = "http://www.entaxy.ru/registry-schema-service/")
        long request
    );

    @WebMethod
    @WebResult(name = "getResourceInfoListResponse", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", partName = "response")
    public GetResourceInfoList getResourceInfoListByFullName(

        @WebParam(partName = "request", name = "getResourceInfoListByFullNameRequest", targetNamespace = "http://www.entaxy.ru/registry-schema-service/")
        GetResourceInfoListByFullNameRequest request
    );

    @WebMethod(action = "http://www.entaxy.ru/registry-schema-service/edit-resourceInfo-info")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", partName = "response")
    public java.lang.String editResourceInfo(

        @WebParam(partName = "request", name = "editResourceInfoRequest", targetNamespace = "http://www.entaxy.ru/registry-schema-service/")
        EditedResourceInfoFullType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/registry-schema-service/get-resourceInfo-info")
    @WebResult(name = "getResourceInfoResponse", targetNamespace = "http://www.entaxy.ru/registry-schema-service/", partName = "response")
    public ResourceInfoFullType getResourceInfo(

        @WebParam(partName = "request", name = "getResourceInfoRequest", targetNamespace = "http://www.entaxy.ru/registry-schema-service/")
        java.lang.String request
    );
}
