/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.executor.objectmodel;

import com.google.gson.JsonObject;

import ru.entaxy.platform.base.support.JSONUtils;
import ru.entaxy.platform.base.support.JSONUtils.ObjectWrapper;

public class FactoryChecker extends JSONUtils.ObjectChecker {

	protected ObjectModel objectModel;
	
	public FactoryChecker(ObjectModel objectModel) {
		this.objectModel = objectModel;
	}
	
	@Override
	public ObjectWrapper checkObject(JsonObject object) {
		if (FactoredObjectRef.isRef(object))
			return new FactoredObjectRef(objectModel);
		if (FactoredObjectProxy.isProxy(object)) {
			return new FactoredObjectProxy(objectModel);
		}
		if (!AbstractFactored.isFactored(object))
			if (Calculation.isCalculated(object))
				return new Calculation(objectModel);
			else			
				return null;
		return new FactoredObject(this.objectModel);
	}

}
