/*-
 * ~~~~~~licensing~~~~~~
 * object-producer-core
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.support;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import org.apache.camel.Exchange;
import org.apache.camel.Processor;

public class ExchangeEnricher implements Processor, MetadataStorageConsumer {

	protected Map<MetadataStorage, String> map = new HashMap<>();
	
	@Override
	public void addStrorage(String prefix, MetadataStorage storage) {
		this.map.put(storage, prefix);
	}

	@Override
	public void process(Exchange exchange) throws Exception {
		
		for (MetadataStorage ms: map.keySet()) {
			Map<String, Object> allData = ms.getAllData();
			String prefix = map.get(ms); 
			for (Entry<String, Object> entry: allData.entrySet()) {
				exchange.getIn().setHeader(prefix + entry.getKey(), entry.getValue());
			}
		}
		
	}

}
