/*-
 * ~~~~~~licensing~~~~~~
 * object-producer-core
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.support;

import java.util.Map;

public class MetadataStorageWrapper extends AbstractConsumerAwareMetadataStorage implements MetadataStorage {

	protected MetadataStorage origin;
	protected MetadataStorage empty = new MetadataStorageEmpty();
	
	public MetadataStorage getOrigin() {
		return origin;
	}

	public void setOrigin(MetadataStorage origin) {
		this.origin = origin;
	}

	protected MetadataStorage getStorage() {
		if (origin != null)
			return origin;
		return empty;
	}
	
	@Override
	public Map<String, String> getStrings() {
		return getStorage().getStrings();
	}

	@Override
	public Map<String, Boolean> getBooleans() {
		return getStorage().getBooleans();
	}

	@Override
	public Map<String, Number> getNumbers() {
		return getStorage().getNumbers();
	}

	@Override
	public Map<String, Object> getAllData() {
		return getStorage().getAllData();
	}

}
