/*-
 * ~~~~~~licensing~~~~~~
 * object-producing-resources-support
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.resources;

import java.util.Map;

import ru.entaxy.platform.core.producer.resources.generator.GeneratedResourceWrapper;

public class DeployableResource extends ResourceDescriptor {

	public Object resourceData;
	public String resourceType;
	
	public DeployableResource(Map<String, Object> properties) {
		super(properties);
		resourceData = properties.get(GeneratedResourceWrapper.OBJECT_KEY);
		resourceType = properties.getOrDefault("type", "unknown").toString();
	}
	
}
