/*-
 * ~~~~~~licensing~~~~~~
 * object-producing-resources-support
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.resources.formatters;

import java.util.Base64;

import org.osgi.service.component.annotations.Component;

import ru.entaxy.platform.core.producer.resources.EntaxyResourceStringFormatter;

@Component (service = EntaxyResourceStringFormatter.class, immediate = true)
public class Base64Formatter implements EntaxyResourceStringFormatter {

	@Override
	public String getName() {
		return "base64";
	}

	@Override
	public String format(String value) {
		return new String(Base64.getEncoder().encode(value.getBytes()));
	}

	@Override
	public String unformat(String value) {
		return new String(Base64.getDecoder().decode(value));
	}
	
}
