/*-
 * ~~~~~~licensing~~~~~~
 * object-producing-resources-support
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.resources.generator;

import java.util.HashMap;
import java.util.Map;

import ru.entaxy.esb.platform.runtime.base.connecting.generator.Generated;
import ru.entaxy.platform.core.producer.resources.ResourceDescriptor;

public class GeneratedResourceWrapper implements Generated {

	public static final String OBJECT_KEY = "#_object"; 
	
	protected Map<String, Object> properties = new HashMap<>();
	
	public GeneratedResourceWrapper (Map<String, Object> props) {
		this.properties.putAll(props);
	}
	
	@Override
	public String getType() {
		return this.properties.getOrDefault("generated.targetType",  
				ResourceDescriptor.RESOURCE_TYPE_PREFIX + properties.getOrDefault("type", "unknown")).toString();
	}

	@Override
	public Object getObject() {
		return this.properties.get(OBJECT_KEY);
	}

	@Override
	public Map<String, Object> getProperties() {
		return this.properties;
	}

}
