/*-
 * ~~~~~~licensing~~~~~~
 * object-producing-shell
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.shell;

import java.util.Map;
import java.util.Map.Entry;

import org.apache.karaf.shell.api.action.Command;
import org.apache.karaf.shell.api.action.lifecycle.Service;
import org.apache.karaf.shell.support.table.ShellTable;

@Service
@Command(scope = EntaxyProducerServiceSupport.SCOPE, name = "factory-type-info")
public class FactoryTypeInfo extends FactoryAwareCommand {

	@Override
	protected Object doExecute() throws Exception {
		
		ShellTable table = new ShellTable();
		table.column("Name");
		table.column("Value");
		
		Map<String, Object> typeInfo = entaxyFactory.getTypeInfo();
		
		for (Entry<String, Object> entry: typeInfo.entrySet()) {
			table.addRow().addContent(
				entry.getKey(),
				entry.getValue()==null?"":entry.getValue().toString()
			);
		}
		
		table.print(System.out);
		return null;
	}

}
