[#ftl]
[#--

    ~~~~~~licensing~~~~~~
    connector-producing
    ==========
    Copyright (C) 2020 - 2023 EmDev LLC
    ==========
    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

         http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
    ~~~~~~/licensing~~~~~~

--]
[#function createQueryString data prefix removePrefix excludes]
	[#assign queryString=""]
	
	[#if excludes??]
		[#assign toExclude=excludes]
	[#else]
		[#assign toExclude=[]]
	[/#if]
	
	[#if properties??]
		[#assign queryString=""]
		[#list properties as key, value]
			[#assign keyAllowed=false]
			[#assign newKey=key]
			[#if prefix??]
				[#if prefix?length>0]
					[#if key?starts_with(prefix)]
						[#if removePrefix]
							[#assign newKey=key[prefix?length..]]
						[/#if]
						[#assign keyAllowed=true]
					[/#if] 
				[/#if] 
			[#else]
				[#assign keyAllowed=true]
			[/#if] 
			[#if !keyAllowed]
				[#continue]
			[/#if]
			[#if keyAllowed && !toExclude?seq_contains(key)]
				[#if value?is_boolean || value?is_number]
					[#assign qsAppend=newKey+"="+value?c]
				[#elseif value?is_string]
					[#assign qsAppend=newKey+"="+value]
				[#else]
					[#assign qsAppend=""]
				[/#if]
				[#if qsAppend?length>0]
					[#if queryString?length>0]
						[#assign queryString=queryString+"&amp;"]
					[/#if]
					[#assign queryString=queryString+qsAppend]
				[/#if]
			[/#if]
		[/#list]	
		[#if queryString?length>0]
			[#assign queryString="?" + queryString]
		[/#if]
	[/#if]
	[#return queryString]           
[/#function]
