/*-
 * ~~~~~~licensing~~~~~~
 * profile-runtime
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.profiles.runtime.impl;

import ru.entaxy.platform.profiles.runtime.Connector;

public abstract class AbstractConnector implements Connector {

	public static final String PROP_ID = "id";
	public static final String PROP_TYPE = "type";
	public static final String PROP_PROTOCOL = "protocol";
	public static final String PROP_CLASSIFIER = "classifier";
	
	public static final String CONNECTOR_PREFIX = "connector.";
	
	protected String id;
	protected String type;
	protected String protocol;
	protected String classifier;
	
	
	@Override
	public String getId() {
		return this.id;
	}

	@Override
	public String getType() {
		return this.type;
	}

	@Override
	public String getProtocol() {
		return this.protocol;
	}

	@Override
	public String getClassifier() {
		return this.classifier;
	}

	@Override
	public String getProperty(String propertyName) {
		String name = propertyName;
		if (name.startsWith(CONNECTOR_PREFIX))
			name = name.substring(CONNECTOR_PREFIX.length());
		if (PROP_ID.equals(name))
			return getId();
		if (PROP_TYPE.equals(name))
			return getType();
		if (PROP_PROTOCOL.equals(name))
			return getProtocol();
		if (PROP_CLASSIFIER.equals(name))
			return getClassifier();
		return null;
	}

	public void setId(String id) {
		this.id = id;
	}

	public void setType(String type) {
		this.type = type;
	}

	public void setProtocol(String protocol) {
		this.protocol = protocol;
	}

	public void setClassifier(String classifier) {
		this.classifier = classifier;
	}

	
	
}
