/*-
 * ~~~~~~licensing~~~~~~
 * profile-commons
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.profile.commons.profile_output;

import org.apache.camel.Exchange;
import org.apache.camel.Header;
import ru.entaxy.esb.system.profile.commons.connectors.out.OutConnector;

import java.util.List;

import static ru.entaxy.esb.system.profile.commons.connectors.Connector.*;

public interface ProfileOutput {
    OutConnector getOutConnector(String endpointName, String role, String type, String subtype);

    void send(Exchange exchange);

    void sendTo(@Header("EndpointName") String endpointName,
                @Header(HEADERS_START + ROLE) String role,
                @Header(HEADERS_START + TYPE) String type,
                @Header(HEADERS_START + SUBTYPE) String subtype,
                Exchange exchange);

    public List<String> getReferenceNames();
}
