/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
var Entaxy;
(function (Entaxy) {
    Entaxy._module
    .component('entaxyModalListWithDescription', {
        bindings: {
            items: '<',
            selectedItem: '<',
            changeSelection: '<'
        },
        template:
        `
          <div class="modal-list-with-description-container">
            <div class="modal-list-with-description-list-container">
              <entaxy-modal-list items="$ctrl.items" selected="$ctrl.selectedItem" change-selection="$ctrl.changeSelection"
                    enable-dbl-click="true" filter="$ctrl.matchesFilter"></entaxy-modal-list>
            </div>
            <div class="modal-description-container">
              <div class="modal-description-title">
                {{$ctrl.title}}
              </div>
              <div class="modal-description-body">
                <div ng-if="$ctrl.selectedItem.description">
                  {{$ctrl.selectedItem.description}}
                </div>
                <div ng-if="!$ctrl.selectedItem.description">
                  There is no selected factory.
                </div>
              </div>
            </div>
          </div>
        `,
        controller: entaxyModalListWithDescriptionController
    })
    .name;

    function entaxyModalListWithDescriptionController() {

        var ctrl = this;

        ctrl.$onInit = function() {
            ctrl.title = 'Factory Description:';
        }

        ctrl.matchesFilter = function(factory, filter) {
            var match = false;

            if (factory.displayName.toLowerCase().match(filter.value.toLowerCase()) !== null ||
                factory.name.toLowerCase().match(filter.value.toLowerCase()) !== null ||
                (factory.label && factory.label.toLowerCase().match(filter.value.toLowerCase()) !== null)) {
                match = true;
                return match;
            }

            return match;
        };
    }

})(Entaxy || (Entaxy = {}));
