/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
var Entaxy;
(function (Entaxy) {
    Entaxy._module
    .component('entaxyXml', {
        bindings: {
            ngModel: '=',
            mode: '<'
        },
        template:
        `
          <button class="entaxy-xml-form" ng-click="$ctrl.openEditor()">{{$ctrl.mode}}</button>
        `,
        controller: entaxyXmlController
    })
    .name;

    function entaxyXmlController(workspace, $uibModal) {
        'ngInject';

        var ctrl = this;

        ctrl.openEditor = function() {

            $uibModal.open({
                component: 'xmlModal',
                resolve: {
                    xml: () => ctrl.ngModel,
                    mode: () => ctrl.mode
                },
                size: 'xl',
                backdrop: 'static',
                windowTopClass: 'modal-top-margin-override'
            })
            .result.then(xml => {
                ctrl.ngModel = xml;
            });
        }
    }
    entaxyXmlController.$inject = ['workspace', '$uibModal'];

})(Entaxy || (Entaxy = {}));
